#
#       HBS REDUCTION SUB ROUTINE
#
#       Correct bad column and pixels : hbsbadpix.cl
#
#       1995/08/01      K.Kawabata  Ver.0.10
#       1997/04/07      K.Kawabata  Ver.1.00  read from HBS.list/hbstrim.cl
#       1998/04/20      K.Kawabata  Ver.2.00  unification
#       1998/05/31      K.Kawabata  Ver.2.10
#       2000/02/29      K.Kawabata  Ver.3.00 for SITe-CCD
#
procedure hbsbadpix

begin

  file fn
  file etcdir
  file fn_def
  file tmp_list, tmp_fn
  string hbslist[500]
  string shorttyp[500], title[500]
  string exptime[500], diaph[500], filter[500]
  string slit[500]
  string listoflist
  string buf=""
  string buf1, buf2, buf3, buf4, buf5, buf6, buf7
  int x
  int n_list
  file logfn
  file fn_orgbadcol
  file fn_orgbadpix
  file fn_bad = "hbs.tmp.badpix"
  int x1, x2, y1, y2, dx, dy
  int a1, a2, b1, b2
  int nccd # 1:TC215 2:SITe
  int flag_auto # 0:query mode 1:no auery
  int flag_ver  # 0:no display 1:display

#--- initial settings

  logfn = envget( "_logfile" )
  etcdir = envget( "_etcdir" )
  fn_def = caldir//envget( "_defhname" )

  listoflist = envget( "_rootlist" )
  fn_def = envget( "_defhdir" )//envget( "_defhname" )
#  fn_orgbadcol = envget( "_badcol" )
#  fn_orgbadpix = envget( "_badpix" )
  tmp_list = mktemp( "hbs.tmp.list." )
  tmp_fn = mktemp( "hbs.tmp.image." )

  if( access( "hbs.tmp.time" ) == 1 )
    delete( "hbs.tmp.time", ver- )
  time >> hbs.tmp.time
  list = "hbs.tmp.time"
  if( fscan( list, buf, buf1, buf2 ) != 3 )
  {
    printf( "Error: time task -- reading\n" )
    bye
  }
  delete( "hbs.tmp.time", ver- )

  print( "" )
  printf( "%s %s\n", buf1, buf2 )
  print( "-----------------------------------" )
  print( " Correction bad columns and pixels" )
  print( "-----------------------------------" )
  print( "" )

  print( "", >> logfn )
  printf( "%s %s\n", buf1, buf2, >> logfn )
  print( "-----------------------------------", >> logfn )
  print( " Correction bad columns and pixels", >> logfn )
  print( "-----------------------------------", >> logfn )
  print( "" ,>> logfn )

  if( access( listoflist ) == 0 )
  {
    print( "Cannot find "//listoflist//"   Please do hbsgroup" )
    print( "Cannot find "//listoflist//"   Please do hbsgroup", >> logfn )
    bye
  }

#----- read difinition file

  nccd = 1     # For old definition file

  buf1 = ""
  buf2 = ""
  buf3 = ""

  if( access( fn_def ) == 0 )
  {
    printf( "Cannot find '%s'\n", fn_def )
    printf( "Cannot find '%s'\n", fn_def, >> logfn )
    bye
  }

  list = fn_def

  while( fscan( list, buf1, buf2, buf3 ) != EOF )
  {
    if( buf2 == "NCCD" )
    {
      nccd = int( buf3 )
    }
  }

#--- Pixel file definition

  if( nccd == 1 )
  {
    fn_orgbadcol = etcdir//"badcol_TI.dat"
    fn_orgbadpix = etcdir//"badpix_TI.dat"
  }
  else
  {
    fn_orgbadcol = etcdir//"badcol_SITe.dat"
    fn_orgbadpix = etcdir//"badpix_SITe.dat"
  }
  
#--- Verbose Mode

  if( envget( "_fg_ver" ) == "1" )
  {
    flag_ver = 1
  }
  else
  {
    if( envget( "_fg_ver" ) == "2" )
    {
      flag_ver = 0
    }
    else
    {
      printf( "'hbsinit' process is incomplete.(_fg_ver) Retry.\n" )
      printf( "'hbsinit' process is incomplete.(_fg_ver) Retry.\n", >> logfn )
      bye
    }
  }

#----- Confirm Each image?

  if( envget( "_fg_badpix" ) == "1" )
  {
    flag_auto = 0
  }
  else
  {
    if( envget( "_fg_badpix" ) == "2" )
    {
      flag_auto = 1
    }
    else
    {
      printf( "'hbsinit' process is incomplete.(_fg_badpix) Retry.\n" )
      printf( "'hbsinit' process is incomplete.(_fg_badpix) Retry.\n",\
              >> logfn )
      bye
    }
  }

#----- read trim data

  x1 = 0
  x2 = 0
  y1 = 0
  y2 = 0

  if( access( fn_def ) == 0 )
  {
    printf( "Cannot find %s\n", ref_def )
    printf( "Cannot find %s\n", ref_def, >> logfn )
    bye
  }
  list = fn_def
  while( fscan( list, buf1, buf2, buf3 ) != EOF )
  {
    if( buf2 == "X1" )
      x1 = int( buf3 )
    if( buf2 == "X2" )
      x2 = int( buf3 )
    if( buf2 == "Y1" )
      y1 = int( buf3 )
    if( buf2 == "Y2" )
      y2 = int( buf3 )
  }
  if( 1.0 * x1 * x2 * y1 * y2 <= 0.00001 )
  {
    printf( "Read error in %s\n", ref_def )
    printf( "Read error in %s\n", ref_def, >> logfn )
    bye
  }
  else
  {
    printf( "x1 = %d  x2 = %d  y1 = %d  y2 = %d\n", x1, x2, y1, y2 )
    printf( "x1 = %d  x2 = %d  y1 = %d  y2 = %d\n", x1, x2, y1, y2, >> logfn )
  }

  dx = x2 - x1 + 1
  dy = y2 - y1 + 1

  if( access( fn_orgbadpix ) )
  {
    print( "Using bad pixel file : ", fn_orgbadpix )
    print( "Using bad pixel file : ", fn_orgbadpix, >> logfn )
  }
  else
  {
    print( "Cannot find bad pixel file:", fn_orgbadpix )
    print( "Cannot find bad pixel file:", fn_orgbadpix, >> logfn )
    bye
  }
  if( access( fn_orgbadcol ) )
  {
    print( "Using bad column file : ", fn_orgbadcol )
    print( "Using bad column file : ", fn_orgbadcol, >> logfn )
  }
  else
  {
    print( "Cannot find bad column file:", fn_orgbadcol )
    print( "Cannot find bad column file:", fn_orgbadcol, >> logfn )
    bye
  }
  if( access( fn_orgbadcol ) == 0 )
  {
    print( "Deleted old temporal file:", fn_bad )
    print( "Deleted old temporal file:", fn_bad, >> logfn )
    delete( fn_bad, ver- )
  }

#----- referring trimming region

  print( "Now modifying the bad column file refering to trimming region..." )
  print( "Now modifying the bad column file refering to trimming region...",\
         >> logfn )
  list = fn_orgbadpix
  while( fscan( list, buf1, buf2, buf3, buf4, buf5 ) != EOF )
  {
    if( substr( buf1, 1, 1 ) == "#" )
      next
    a1 = int( buf1 ) - x1 + 1
    a2 = int( buf2 ) - x1 + 1
    b1 = int( buf3 ) - y1 + 1
    b2 = int( buf4 ) - y1 + 1
    if( a1 > 0 && a2 <= dx && b1 > 0 && b2 <= dy )
      printf( "%4d %4d %4d %4d\n", a1, a2, b1, b2, >> fn_bad )
  }
  list = fn_orgbadcol
  while( fscan( list, buf1, buf2, buf3, buf4, buf5 ) != EOF )
  {
    if( substr( buf1, 1, 1 ) == "#" )
      next
    a1 = int( buf1 ) - x1 + 1
    a2 = int( buf2 ) - x1 + 1
    b1 = 1
    b2 = dy
    if( a1 > 0 && a2 <= dx )
      printf( "%4d %4d %4d %4d\n", a1, a2, b1, b2, >> fn_bad )
  }
  if( access( fn_bad ) == 0 )
  {
    printf( "\nNo bad pixel is defined.  Task finished.\n" )
    printf( "\nNo bad pixel is defined.  Task finished.\n", >> logfn )
    bye
  }

#----- scanning the list file

  n_list = 0
  list = listoflist
  while( fscan(list, buf1, buf2, buf3, buf4, buf5, buf6, buf7) != EOF )
  {
    if( substr( buf1, 1, 3 ) != "HBS" )
    {
      print( "The list-file ", listoflist, " is not produced by HBSGROUP.CL" )
      print( "The list-file ", listoflist, " is not produced by HBSGROUP.CL",\
             >> logfn )
      break
    }
    n_list += 1
    hbslist[n_list] = buf1
    shorttyp[n_list] = buf2
    title[n_list] = buf3
    exptime[n_list] = buf4
    diaph[n_list] = buf5
    filter[n_list] = buf6
    slit[n_list] = buf7
  }

#----- correcting

  print( "Now correcting bad pixels..." )
  print( "Now correcting bad pixels...", >> logfn )
  for( i=1; i<=n_list; i+=1 )
  {
    if( shorttyp[i] != "DAR" && shorttyp[i] != "BIA" &&\
        shorttyp[i] != "NEA" )
    {
      if( flag_ver == 1 )
        printf( "\n---  OBJECT LIST :%s ---\n", hbslist[i] )
      printf( "\n---  OBJECT LIST :%s ---\n", hbslist[i], >> logfn )
      sed( 's/fit\.imh//', hbslist[i], > tmp_list )
      list = tmp_list
      while( fscan( list, fn ) != EOF )
      {
        buf1 = fn//"tr"

	if( access( buf1//".imh" ) == 0 )
	{
          if( flag_ver == 1 )
            printf( "%s--not found. skip.  ", buf1 )
          printf( "%s--not found. skip.  ", buf1, >> logfn )
	  next
	}
        if( flag_ver == 1 )
	  printf( "%s  ", buf1 )
        printf( "%s  ", buf1, >> logfn )
	if( flag_auto == 1 )
	{
	  fixpix( buf1, fn_bad )
          hedit( buf1, 'HISTORY3', "bad pixel cor. "\
                 //fn_orgbadpix//" and "//fn_orgbadcol, add+, del-,\
                 ver-, show-, update+, mode=mode )
        }
	else
	{
nextstep1:
          print( "displaying original ", buf1 )
          print( "displaying original ", buf1, >> logfn )
          display( buf1, 1 )
          printf( "[RET]:display corrected image  [n]:no correction  >> " )
          printf( "[RET]:display corrected image  [n]:no correction  >> ",\
                   >> logfn )
          x = scan(buf)
          while( x != 0  && buf != "n" )
            x = scan(buf)
          printf( "%s\n", buf, >> logfn )
          if( x == 0 )
          {
            imcopy( input=buf1, output=tmp_fn, ver- )
            fixpix( tmp_fn, fn_bad )
            hedit( tmp_fn, 'HISTORY', "bad pixel cor. "\
                   //fn_orgbadpix//" and "//fn_orgbadcol, add+, del-,\
                   ver-, show-, update+, mode=mode )

            print( "displaying corrected ", buf1 )
            print( "displaying corrected ", buf1, >> logfn )
            display( tmp_fn, 1 )
            printf( "[RET]:update and next  [c]:cancel  [e]:enter auto mode >> " )
            printf( "[RET]:update and next  [c]:cancel  [e]:enter auto mode >> ", >> logfn )
            x = scan(buf)
            while( x != 0  && buf != "c" && buf != "e" )
              x = scan(buf)
            printf( "%s\n", buf, >> logfn )
            if( buf == "c" )
            {
              imdelete( tmp_fn )
              goto nextstep1
            }
            else
            {
              if( buf == "e" )
              {
                imdelete( buf1, ver- )
                imrename( oldname=tmp_fn, newname=buf1 )
                flag_auto = 1
		print( "OK. Entering the automatic mode..." )
		print( "OK. Entering the automatic mode...", >> logfn )
              }
              else
              {
                imdelete( buf1, ver- )
                imrename( oldname=tmp_fn, newname=buf1 )
              }
	    }
	  }
        }
      }
      delete( tmp_list, ver- )

      if( flag_ver == 1 )
        printf( "\n" )
      printf( "\n", >> logfn )
    }
  }
  delete( fn_bad, ver- )

end
