#
#       HBS REDUCTION SUB ROUTINE
#
#       identify of wavelength calibration spectrum
#                   for distortion correction: hbspreidentify.cl
#
#       1997/07/10      K.Kawabata  Ver.0.10
#

procedure hbspreidentify

begin

  file listoflist = "HBS.list"
  string hbslist[50]
  string shorttyp[50], title[50]
  string exptime[50], diaph[50], filter[50]
  string slit[50]
  int c, i, j, n, n_list, n_image
  int x_order = 6
  int f_wid = 5
  string buf1, buf2, buf3, buf4, buf5, buf6, buf7
  file fns
  file tmp_list1, tmp_list2, tmp_list3, tmp_list4, tmp_lista
  file tmp_image = "dispref.px.0"
  file ref_fn1 = "dispref.px.1"
  file ref_fn2 = "dispref.px.2"
  file ref_fn3 = "dispref.px.3"
  file ref_fn4 = "dispref.px.4"
  string buf=""
  string fitsec="middle line"
  string wavelist
  string ref_dir


  tmp_lista = mktemp( "hbs.tmp.list." )
  tmp_list1 = mktemp( "hbs.tmp.list." )
  tmp_list2 = mktemp( "hbs.tmp.list." )
  tmp_list3 = mktemp( "hbs.tmp.list." )
  tmp_list4 = mktemp( "hbs.tmp.list." )

  print( "" )
  print( "----------------------------------------------------" )
  print( " identifucation of the lines in a comparison images" )
  print( "----------------------------------------------------" )
  print( "" )


#----- delete old images

  if( access( tmp_image//".imh" ) == 1 )
    imdelete( tmp_image, ver- )

findoldimage:

  if( access( ref_fn1//".imh" ) || access( ref_fn2//".imh" ) ||\
      access( ref_fn3//".imh" ) || access( ref_fn4//".imh" ) )
  {
    print( "old reference images exist. Use them? (y/n) " )
    c = scan( buf )
    while( buf != "y" && buf != "n" )
      c = scan( buf )
    if( buf == "n" )
    {
      imdelete( ref_fn1, ver- )
      imdelete( ref_fn2, ver- )
      imdelete( ref_fn3, ver- )
      imdelete( ref_fn4, ver- )
      goto findoldimage
    }
  }
  else
  {

#----- Scanning the list file

    if( access( listoflist ) == 0 )
    {
      print( "Cannot find "//listoflist//"   Please do hbsgroup" )
      bye
    }
    n_list = 0
    list = listoflist
    while( fscan(list, buf1, buf2, buf3, buf4, buf5, buf6, buf7) != EOF )
    {
      if( substr( buf1, 1, 3 ) != "HBS" )
      {
        print( "The list-file ", listoflist, " is not produced by HBSGROUP.CL" )
        break
      }
      if( buf2 != "OBJ" && buf2 != "COM" )
        next
      n_list += 1
      hbslist[n_list] = buf1
      shorttyp[n_list] = buf2
      title[n_list] = buf3
      exptime[n_list] = buf4
      diaph[n_list] = buf5
      filter[n_list] = buf6
      slit[n_list] = buf7
    }

#---- selection of images for summation

    if( access( tmp_lista ) == 1 )
      delete( tmp_lista, ver- )

    for( i=1; i<=n_list; i+=1 )
    {
     printf( "%2d: %16s  %6s  %s\n", i, hbslist[i], title[i], diaph[i] )
    }
nextstep1:
    printf( "Select a group to be sum ([e]:end selection) >> " )
    while( scan( buf ) != 1 ){}
    if( buf == "e" )
      goto nextstep2
    k = int( buf )
    if( k < 1 || k > n_list )
      goto nextstep1
    printf( "object %s   diaphragm %s  slit width %s\n",\
            title[k], diaph[k], slit[k] )
    if( real( slit[k] ) > 1.0 )
    {
      printf( "Warning: Slit width of %s is too wide.\n", hbslist[k] )
    }
    type( hbslist[k], >> tmp_lista )
    goto nextstep1

nextstep2:
  
#----- summing images

    sed( 's/\.fit\./\.px\.1\./', tmp_lista, > tmp_list1 )
    sed( 's/\.fit\./\.px\.2\./', tmp_lista, > tmp_list2 )
    sed( 's/\.fit\./\.px\.3\./', tmp_lista, > tmp_list3 )
    sed( 's/\.fit\./\.px\.4\./', tmp_lista, > tmp_list4 )
    delete( tmp_lista, ver- )

    n_image = 0
    list = tmp_list1
    while( fscan( list, buf) != EOF )
    {
      n_image += 1
    }
    printf( "Now making summed images of Sp.1  %d image(s)\n", n_image )
    imsum( input="@"//tmp_list1, output=ref_fn1, hparam="EXPTIME",\
           option="sum", ver- )
    delete( tmp_list1, ver- )

    n_image = 0
    list = tmp_list2
    while( fscan( list, buf ) != EOF )
    {
      n_image += 1
    }
    printf( "Now making summed images of Sp.2  %d image(s)\n", n_image )
    imsum( input="@"//tmp_list2, output=ref_fn2, hparam="EXPTIME",\
            option="sum", ver- )
    delete( tmp_list2, ver- )

    n_image = 0
    list = tmp_list3
    while( fscan( list, buf) != EOF )
    {
      n_image += 1
    } 
    printf( "Now making summed images of Sp.3  %d image(s)\n", n_image )
    imsum( input="@"//tmp_list3, output=ref_fn3, hparam="EXPTIME",\
            option="sum", ver- )
    delete( tmp_list3, ver- )

    n_image = 0
    list = tmp_list4
    while( fscan( list, buf) != EOF )
    {
      n_image += 1
    }
    printf( "Now making summed images of Sp.4  %d image(s)\n", n_image )
    imsum( input="@"//tmp_list4, output=ref_fn4, hparam="EXPTIME",\
            option="sum", ver- )
    delete( tmp_list4, ver- )

  }

#----- select type

  print( "image type  [h]:Hg-Ne [i]:nebula [n]:TI-CCD >>" )
  c = scan( buf )
  while( buf != "h" && buf != "i" && buf != "n" )
    c = scan( buf )
  if( buf == "h" )
    wavelist = "home$etc/Hg-Ne.dat"
  if( buf == "i" )
    wavelist = "home$etc/hbsnebula.dat"
  if( buf == "n" )
    wavelist = "home$etc/hbscryocam1.dat"
  type( wavelist )

#----- identify the middle line of the first spectrum

  if( access( "database/fc"//ref_fn1 ) )
    delete( "database/fc"//ref_fn1, ver- )
  if( access( "database/fc"//ref_fn2 ) )
    delete( "database/fc"//ref_fn2, ver- )
  if( access( "database/fc"//ref_fn3 ) )
    delete( "database/fc"//ref_fn3, ver- )
  if( access( "database/fc"//ref_fn4 ) )
    delete( "database/fc"//ref_fn4, ver- )

  imcopy( ref_fn2, tmp_image, ver- )
  if( access( "database/id"//tmp_image ) )
    delete( "database/id"//tmp_image, ver- )

  printf( "push [m] key on the feature, and input wavelength\n" )
  identify( tmp_image//".imh", section=fitsec, databas='database',\   
            coordli=wavelist, nsum=10, match=20.,\
            maxfeat=30, fwidth=f_wid, cradius=10., functio='chebyshev',\
            order=x_order, niterate=10, low_rej=3., high_rej=3., autowrite+,\
            grow=0., ftype='emission', mode='ql', thresho=3. )

#----- re-identify the other lines of the first spectrum

#----- re-identify the other spectra

  if( access( "database/id"//ref_fn1 ) )
    delete( "database/id"//ref_fn1, ver- )
  if( access( "database/id"//ref_fn2 ) )
    delete( "database/id"//ref_fn2, ver- )
  if( access( "database/id"//ref_fn3 ) )
    delete( "database/id"//ref_fn3, ver- )
  if( access( "database/id"//ref_fn4 ) )
    delete( "database/id"//ref_fn4, ver- )

  fns = ref_fn1//","//ref_fn2//","//ref_fn3//","//ref_fn4

  reidentify( reference=tmp_image, images=fns, answer+, interac-,\
              step=5, newaps-, override+, refit+,\
	      trace+, nsum=10, shift=0., nlost=0, cradius=5.,\
	      threshold=3., addfeatures-, coordlist=wavelist,\
	      match=10, maxfeatures=30, minsep=5, databas='database',\   
              logfiles="", plotfile="", ver+, graphics="stdgraph",\
	      cursor="", mode='ql' )

#  if( access( "database/id"//tmp_image ) )
#    delete( "database/id"//tmp_image, ver- )
  if( access( tmp_image//".imh" ) )
    imdelete( tmp_image, ver- )

#----- fit coordinations

  if( access( "database/fc"//ref_fn1 ) )
    delete( "database/fc"//ref_fn1, ver- )
  if( access( "database/fc"//ref_fn2 ) )
    delete( "database/fc"//ref_fn2, ver- )
  if( access( "database/fc"//ref_fn3 ) )
    delete( "database/fc"//ref_fn3, ver- )
  if( access( "database/fc"//ref_fn4 ) )
    delete( "database/fc"//ref_fn4, ver- )

  fitcoords( ref_fn1, fitname="", interactive+, combine-,\
             database="database", function="chebyshev", xorder=x_order,\
	     yorder=2, logfiles="STDOUT", plotfile="plotfile",\
	     graphics="stdgraph", cursor="", mode="ql" )
  fitcoords( ref_fn2, fitname="", interactive+, combine-,\
             database="database", function="chebyshev", xorder=x_order,\
	     yorder=2, logfiles="STDOUT", plotfile="plotfile",\
	     graphics="stdgraph", cursor="", mode="ql" )
  fitcoords( ref_fn3, fitname="", interactive+, combine-,\
             database="database", function="chebyshev", xorder=x_order,\
	     yorder=2, logfiles="STDOUT", plotfile="plotfile",\
	     graphics="stdgraph", cursor="", mode="ql" )
  fitcoords( ref_fn4, fitname="", interactive+, combine-,\
             database="database", function="chebyshev", xorder=x_order,\
	     yorder=2, logfiles="STDOUT", plotfile="plotfile",\
	     graphics="stdgraph", cursor="", mode="ql" )

end
