#
#       HBS REDUCTION SUB ROUTINE
#
#       Scan and extract one-dimensional spectra 
#                                               : hbsscan1d.cl
#
#       1997/03/21      K.Kawabata  Ver.0.10  for CRYOCAM manual reduc
#

procedure hbsscan1d( inlist, ref_dir1 )

file inlist	{ prompt = "Input grouped list to be proccessed" }
string ref_dir1 { prompt = "Directry where slice data exists" }


begin

  file hbslist, fn, fn1, fn2
  file fn_scan = "prescan.px"
  file tmp_list1
  string buf, buf1, buf2, buf3, buf4
  real slicelevel = 0.005
  string ref_dir
  int c

  hbslist = inlist
  ref_dir = ref_dir1

  tmp_list1 = mktemp( "hbs.tmp.list." )
  sed( 's/d\.imh//', hbslist, > tmp_list1 )

  if( access( ref_dir//fn_scan//".imh" ) == 0 )
  {
    print( "image '"//ref_dir//fn_scan//"' not found" )
    bye
  }

  if ( access( ref_dir//'database/ap'//fn_scan) == 0 )
  {
    print( "image '"//ref_dir//fn_scan//"' may not be prescanned" )
    bye
  }

  if( access( 'database/ap'//fn_scan ) == 1 )
  {
    print( "overwrite the database ? (y/n)" )
    c = scan( buf )
    while( buf != "y" && buf != "n" )
      c = scan( buf )
    if( buf == "n" )
      goto nextstep1
    delete( 'database/ap'//fn_scan, ver- )
  }
  if( access( 'database' ) == 0 )
    mkdir( "database" )
  copy( ref_dir//'database/ap'//fn_scan, "./database/", ver- )


nextstep1:

#----- scan and extract

  list = tmp_list1
  while( fscan( list, fn ) != EOF ){

#    fn1 = fn//"c1"
    fn1 = fn//"px"
    fn2 = fn//"ms"
    buf1 = fn//"0001"
    buf2 = fn//"0002"
    buf3 = fn//"0003"
    buf4 = fn//"0004"

    print( "Now scanning "//fn1 )

    apall( input=fn1, nfind=4, output=fn2, format="multispec",\
           reference=fn_scan, profiles="", interac-, find-, recenter+,\
	   resize-,\
           edit-, trace-, fittrace-, extract+, extras-, review-, line=INDEF,\
           nsum=3, apertures="1-4", npeaks=2, shift+, background="none",\
           weights="none", pfit="fit1d", clean-, skybox=1, saturation=50000,\
           readnoise=8., gain=0.26, lsigma=4., usigma=4. )


    hedit( fn2, "HISTORY", "spectrum extracted refering to "\
           //fn_scan, delete-, verify-, show-, update+ )
    hbscoord( fn2 )
    hedit( fn2, "DISPAXIS", "1", add+, delete-, verify-, show-, update+ )

    imcopy( fn2//"[*,1:1]", buf1, ver- )
    imcopy( fn2//"[*,2:2]", buf2, ver- )
    imcopy( fn2//"[*,3:3]", buf3, ver- )
    imcopy( fn2//"[*,4:4]", buf4, ver- )
    imdelete( fn2, ver- )
  }

  delete( tmp_list1, ver- )

end
